/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 4, maxerr: 50 */
/*global $, Folder*/


function getActiveDocumentName() {
  return app.activeDocument.name;
}

function checkContext() {
  return String(app.documents.length > 0);
}

function exportFile() {
  var filePath = app.activeDocument.fullName;
  return File(filePath).fsName;
}

//replace opeation to remove entire swatches in swatch panel
function CheckforSwatchGroup(swatchGroupName) {
  var doc = app.activeDocument; // get the doc
  // loop all groups and remove the each swatchegroup
  for (var i = doc.swatchGroups.length - 1; i >= 0; i--) {
    doc.swatchGroups[i].remove();
  }
  return true;
}

//Append operation : if swatch group already there. 
function refreshSwatchGroup(swatchGroupName) {
  //alert("In JSX");
  var doc = app.activeDocument; // get the doc
  try {
    for (var i = doc.swatchGroups.length - 1; i >= 0; i--) {
      if (doc.swatchGroups[i].name == swatchGroupName) {
        doc.swatchGroups[i].remove();
        //alert("removed");
      }
    }

  }
  catch (e) {
    //alert("not there");
  }
}




function addSwtchestoGroupLABColors(swatchGroupName, swatchName, swatchValue, swatchLAB_L, swatchLAB_A, swatchLAB_B) {
  //alert(swatchLAB_A);
  var doc = app.activeDocument;
  try {
    var swGrp = doc.swatchGroups.getByName(swatchGroupName);

    var newSpot = doc.spots.add();
    newSpot.name = decodeURIComponent(swatchName);
  }
  catch (e) {

    var swGrp = doc.swatchGroups.add();
    swGrp.name = swatchGroupName;
    var newSpot = doc.spots.add();
    newSpot.name = decodeURIComponent(swatchName);
  }
  finally {

    //var rbgValue = hexToRgb(swatchValue);
    //var newSpot = doc.spots.add();  

    var RBGValues = new LabColor();    //add swatch color based on rgb values

    RBGValues.l = swatchLAB_L;
    RBGValues.a = swatchLAB_A;
    RBGValues.b = swatchLAB_B;


    // RBGValues.l = swatchLABArray[0];
    // RBGValues.a = swatchLABArray[1];
    // RBGValues.b = swatchLABArray[2];

    //alert("a "+RBGValues.a);
    //alert(swatchValue.r,swatchValue.g,swatchValue.b);

    newSpot.colorType = ColorModel.SPOT;
    newSpot.color = RBGValues;
    swGrp.addSpot(newSpot);

    return swGrp;
  }
}


function matchWithAllSwatches() {
  var doc = app.activeDocument;
  var matched = false;
  for (var i = doc.swatchGroups.length - 1; i >= 0; i--) {
    var inksINSwatch = doc.swatchGroups[i].getAllSwatches();
    //alert(inksINSwatch);
    //alert(inksINSwatch.length);
    for (var j = 0; j < inksINSwatch.length; j++) {
      var red = inksINSwatch[j].color.red;
      var green = inksINSwatch[j].color.green;
      var blue = inksINSwatch[j].color.blue;
      //alert(inksINSwatch[j]+" okkk  lightness");
      //alert(red+" "+blue+" "+green+" okkk  lightness");
      alert(inksINSwatch[j].spotKind + " ..../...ok");
    }
    return matched;
  }
  //return matched;
}

function addSwtchestoGroup(swatchGroupName, swatchName, swatchValue) {

  var doc = app.activeDocument;
  try {
    var swGrp = doc.swatchGroups.getByName(swatchGroupName);
    var newSpot = doc.spots.add();
    newSpot.name = swatchName;
    //alert(rbgValue.g);
  }
  catch (e) {

    var swGrp = doc.swatchGroups.add();
    swGrp.name = swatchGroupName;
    var newSpot = doc.spots.add();
    newSpot.name = swatchName;
  }
  finally {

    var rbgValue = hexToRgb(swatchValue);
    //var newSpot = doc.spots.add();  



    var RBGValues = new RGBColor();    //add swatch color based on rgb values
    RBGValues.green = rbgValue.g;
    RBGValues.blue = rbgValue.b;
    RBGValues.red = rbgValue.r;



    newSpot.colorType = ColorModel.SPOT;
    newSpot.color = RBGValues;
    swGrp.addSpot(newSpot);

    return swGrp;
  }
}


function hexToRgb(hex) {                                                 // needed  code because data comes to jsx as string , isntead of object  : need more clearance 
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  return result ? {
    r: parseInt(result[1], 16),
    g: parseInt(result[2], 16),
    b: parseInt(result[3], 16)
  } : null;
}


function openDocOnHost(filepath) {
  var fileRef = new File(filepath);
  if (fileRef.exists) {
    app.open(fileRef);
  }
}

function placeImageOn(targetCode, imageType, src) {

  var doc = app.activeDocument;
  if (!doc) {
    return;
  }

  for (var lIndex = 0; lIndex < doc.layers.length; lIndex++) {
    var cLayer = doc.layers[lIndex];
    for (var i = 0; i < cLayer.textFrames.length; i++) {
      var tFr = cLayer.textFrames[i];
      if (tFr.contents == targetCode) {
        var x = tFr.left;
        var y = tFr.top;
        try { // if  document or the  layer is locked.
          _placeImageOnDocument(doc, imageType, src, x, y);
        } catch (e) {
          //alert("unable to create");
          // do nothing 
          // tFr.remove();
          // return;
        }
        finally {
          tFr.remove();
          return;
        }
      }
    }
  }
}

function placeImageOnButtonClick(imageType, imageFilePath) {
  //This method is executed on click of Place button in Document Details view
  //As this is a click event, cannot use/find mouse cursor position
  //So place image at the center of active document

  //Get active document
  var doc = app.activeDocument;

  if (null != doc) {
    //Place image at the center of the document
    _placeImageAtCenterOfDocument(doc, imageType, imageFilePath);
  }
}

function _placeImageAtCenterOfDocument(doc, imageType, imageFilePath) {
  if ("image" == imageType) {
    var rasterFile = File(imageFilePath);
    var newPlacedItem = doc.placedItems.add();
    newPlacedItem.file = rasterFile;

    //Get document width and height
    var docWidth = doc.width;
    var docHeight = doc.height;

    //Get placed image width and height
    var placedItemWidth = newPlacedItem.width;
    var placedItemHeight = newPlacedItem.height;

    //If image width or height is greater than doc size, reduce image size to 70% of doc size while maintaining aspect ratio
    var docAspectRatio = docWidth / docHeight;
    var imageAspectRatio = placedItemWidth / placedItemHeight;
    if ((placedItemWidth >= docWidth) || (placedItemHeight >= docHeight)) {
      if (imageAspectRatio > docAspectRatio) {
        newPlacedItem.width = 0.7 * docWidth;
        newPlacedItem.height = newPlacedItem.width / imageAspectRatio;
      }
      else {
        newPlacedItem.height = 0.7 * docHeight;
        newPlacedItem.width = newPlacedItem.height * imageAspectRatio;
      }
    }

    //Place image at the center of the document
    //So placed image's center should coincide with document's center
    //Document center point is at (docWidth/2, -docHeight/2)
    //Compute start position where image needs to be placed
    var xPos = 0; var yPos = 0;
    xPos = (docWidth - newPlacedItem.width) / 2;
    yPos = -(docHeight - newPlacedItem.height) / 2;

    //Set position of placed image
    newPlacedItem.position = Array(xPos, yPos);
    newPlacedItem.embed();
  }
  else if ("vector" == imageType) {
    var embedDoc = new File(imageFilePath);
    var placed = doc.groupItems.createFromFile(embedDoc);
  }
}

function _placeImageOnDocument(doc, imageType, imageFilePath, xCoord, yCoord) {
  if ("image" == imageType) {
    var rasterFile = File(imageFilePath);
    var newPlacedItem = doc.placedItems.add();
    newPlacedItem.file = rasterFile;
    newPlacedItem.position = Array(xCoord, yCoord);
    newPlacedItem.embed();
  }
  else if ("vector" == imageType) {
    var embedDoc = new File(imageFilePath);
    var placed = doc.groupItems.createFromFile(embedDoc);
  }
}

function removeDefualtDropedText(targetCode, imageType, filePath) {
  var currPageItem = app.activeDocument;
  // do nothing since text dropped is already removed in previous method
}

function removeDropedText(targetCode, imageType, filePath) {
  var doc = app.activeDocument;
  if (!doc) {
    return;
  }
  for (var lIndex = 0; lIndex < doc.layers.length; lIndex++) {
    var cLayer = doc.layers[lIndex];
    for (var i = 0; i < cLayer.textFrames.length; i++) {
      var tFr = cLayer.textFrames[i];
      if (tFr.contents == targetCode) {
        tFr.remove();
      }
    }
  }
}

function findInfo() {
  //alert("to get info from host to jsx");
  var document = app.activeDocument;
  var prodInfo = new Array;
  // This first section of the Illustrator script will just get the template name of the current product.  
  var templateName = new String;
  // alert("total layers : "+ document.layers.length);
  var templateLayer = document.layers[0];
  for (var i = templateLayer.pageItems.length - 1; i >= 0; i--) {
    var pName = templateLayer.pageItems[i].name;
    if (pName != "") {
      templateName = templateLayer.pageItems[i].name;
    }
  }
  var allColor = new Array;
  var colorsArray = [];
  var bHalftones = false;
  var bFourCP = false;
  var bReg = false;
  colorsInUse(document);
  function colorsInUse(currPageItem) {
    //alert("total Parent Item"+currPageItem.pageItems.length);        
    for (var i = 0; i < currPageItem.pageItems.length; i++) {
      // Stepping through each item on the layer.  
      var currentItem = currPageItem.pageItems[i];
      // $.writeln("current item is " + currentItem.typename);  
      // $.writeln("Does it have a fill color? " + currentItem.fillColor);  
      // alert("Item Type"+currentItem.typename); 

      if (currentItem.typename === "GroupItem" && !currentItem.guides) {
        // If it's a group, dig into the group and start the function over.  
        colorsInUse(currentItem);

      } else if (currentItem.typename == "TextFrame") {
        // alert("its a text frame going to get colors");
        var charAttrib = currentItem.textRange.characterAttributes;
        getColors(charAttrib, colorsArray);

      } else if (currentItem.typename === "RasterItem") {
        if (currentItem.imageColorSpace === ImageColorSpace.CMYK) {
          // alert("Four-color Raster process image in artwork.");      
          //$.writeln("Four-color process image in artwork.");  
        } else if (currentItem.channels > 1 || currentItem.imageColorSpace === ImageColorSpace.GrayScale) {
          if (currentItem.colorants[0] === "Gray") {
            if (colorsArray.toString().indexOf("Black") === -1) {
              colorsArray.push("Black");
            }
            alert("When this script is finished, please verify that the Ink/PMS table has the correct colors.");
          } else {
            if (colorsArray.toString().indexOf(currentItem.colorants[0]) === -1) {
              colorsArray.push(currentItem.colorants[0]);
            }
          }

        } else {
          alert("The raster image in the art file must be a 1-channel bitmap and, thus, script cannot determine its color.");
        }
      } else if ((currentItem.fillColor || currentItem.strokeColor) && !currentItem.guides) {
        // If the current object has either a fill or a stroke, continue.  
        if (currentItem.pathPoints.length > 2 || (currentItem.pathPoints == 2 && currentItem.stroked && currentItem.strokeWidth >= 0.1)) {
          // If the current object has 2 points and a good stroke, or more than two points, continue.  
          getColors(currentItem, colorsArray);
        }
      } else if (currentItem.typename === "CompoundPathItem") {
        //alert("has compound path"); 
        for (var c = 0; c < currentItem.pathItems.length; c++) {
          if (currentItem.pathItems[c].pathPoints.length > 2 || (currentItem.pathItems[c].pathPoints == 2 && currentItem.pathItems[c].stroked && currentItem.pathItems[c].strokeWidth >= 0.1)) {
            // If the current object has 2 points and a good stroke, or more than two points, continue.  
            getColors(currentItem.pathItems[c], colorsArray);
          }
        }

      }

    }
    return;
  }
  function getColors(currentItem, colorsArray) {
    //alert("get Colors"); 
    var thisColor = {};
    try {
      var fillColorType = currentItem.fillColor.typename;
      var strokeColorType = currentItem.strokeColor.typename;
      //alert("fillColorType is: " + fillColorType);     

      switch (fillColorType) {

        case "RGBColor":

          var mRed = currentItem.fillColor.red;
          var mGreen = currentItem.fillColor.green;
          var mBlue = currentItem.fillColor.blue;
          var mRGBarray = [mRed, mGreen, mBlue];
          //alert(mRGBarray);

          var myCMYKresult = app.convertSampleColor(ImageColorSpace.RGB, mRGBarray, ImageColorSpace.CMYK, ColorConvertPurpose.defaultpurpose);
          //alert(myCMYKresult);
          var mCMYkarray = myCMYKresult.splice(",");
          //alert(mCMYkarray[0]);
          thisColor["type"] = "fillColorRGB";
          thisColor["cyan"] = (mCMYkarray[0]);
          thisColor["magenta"] = (mCMYkarray[1]);
          thisColor["yellow"] = (mCMYkarray[1]);
          thisColor["black"] = (mCMYkarray[2]);

          thisColor["rgb"] = mRGBarray;

          allColor.push(thisColor);
          bFourCP = true;
          bHalftones = true;
          break;

        case "CMYKColor":

          if (currentItem.fillColor.cyan === 0 && currentItem.fillColor.magenta === 0 && currentItem.fillColor.yellow === 0)    // todo: do we need to extract half tones 
          {
            if (currentItem.fillColor.black > 0) {
              if (colorsArray.toString().indexOf("Black") === -1) {
                colorsArray.push("Black");
              }
              if (currentItem.fillColor.black < 100) {
                bHalftones = true;
              }
            }
          }
          else {
            var colormyArray = [(currentItem.fillColor.cyan), (currentItem.fillColor.magenta), (currentItem.fillColor.yellow), (currentItem.fillColor.black)];
            //alert("..C : "+currentItem.fillColor.cyan+"  M : "+currentItem.fillColor.magenta+"  Y : "+currentItem.fillColor.yellow+" K :"+currentItem.fillColor.black);
            thisColor["type"] = "fillColorCMYK";
            thisColor["cyan"] = (currentItem.fillColor.cyan);
            thisColor["magenta"] = (currentItem.fillColor.magenta);
            thisColor["yellow"] = (currentItem.fillColor.yellow);
            thisColor["black"] = (currentItem.fillColor.black);

            var myColorArray = [thisColor["cyan"], thisColor["magenta"], thisColor["yellow"], thisColor["black"]];
            var myresult = app.convertSampleColor(ImageColorSpace.CMYK, myColorArray, ImageColorSpace.RGB, ColorConvertPurpose.defaultpurpose);

            thisColor["rgb"] = myresult;
            //alert("rgb string "+rgbString);



            var result = new LabColor();
            //var result= new LabColor().hostObjectDelegate;
            sourceColorSpace = ImageColorSpace.CMYK;

            destColorSpace = ImageColorSpace.LAB;
            //app.beep();
            result = app.convertSampleColor(ImageColorSpace.CMYK, colormyArray, ImageColorSpace.LAB, ColorConvertPurpose.defaultpurpose);
            //thisColor["black"]=currentItem.fillColor.black;

            var myColorArray = [84.43504883269401, -20.19287432631017, 85.1489508783648];
            var myresult = app.convertSampleColor(ImageColorSpace.LAB, myColorArray, ImageColorSpace.CMYK, ColorConvertPurpose.defaultpurpose);
            //alert(myresult);
            //var myResult=app.colorTransform(currentItem.fillColor, currentItem.fillColor.typename, ColorSpace.LAB);
            allColor.push(thisColor);
            //alert("cyan: "+currentItem.fillColor.cyan+" magenta: "+currentItem.fillColor.magenta+" yellow: "+currentItem.fillColor.yellow);   
            // alert(currentItem.fillColor.SwatchName);
            //console.log(thisColor);
            //alert(thisColor);
            bFourCP = true;
            bHalftones = true;
          }
          break;

        case "GrayColor":

          if (currentItem.fillColor.gray > 0) {
            if (colorsArray.toString().indexOf("Black") === -1) {
              colorsArray.push("Black");
            }
            if (currentItem.fillColor.gray < 100) { bHalftones = true; }
          }
          break;


        case "SpotColor":

          if (colorsArray.toString().indexOf(currentItem.fillColor.spot.name) === -1 && currentItem.fillColor.spot.name.toLowerCase().indexOf("white") === -1) {
            // alert("spot colors");

            colorsArray.push(currentItem.fillColor.spot.name);

            if ((app.activeDocument.documentColorSpace) == "DocumentColorSpace.RGB") {    // if the active document  created  in RGB mode

              var mRGBarray = [(currentItem.fillColor.spot.color.red), (currentItem.fillColor.spot.color.green), (currentItem.fillColor.spot.color.blue)];
              //alert(mRGBarray);
              var myCMYKresult = app.convertSampleColor(ImageColorSpace.RGB, mRGBarray, ImageColorSpace.CMYK, ColorConvertPurpose.defaultpurpose);
              //alert(myCMYKresult);
              var mCMYkarray = myCMYKresult.splice(",");
              //alert(mCMYkarray[0]);
              thisColor["type"] = "fillColorRGB";
              thisColor["cyan"] = (mCMYkarray[0]);
              thisColor["magenta"] = (mCMYkarray[1]);
              thisColor["yellow"] = (mCMYkarray[1]);
              thisColor["black"] = (mCMYkarray[2]);

              thisColor["rgb"] = mRGBarray;

              allColor.push(thisColor);

              //app.activeDocument.documentColorSpace="DocumentColorSpace.CMYK";
            }

            else if ((app.activeDocument.documentColorSpace) == "DocumentColorSpace.CMYK") {    // if the active document  created  in CMYK mode
              thisColor["type"] = "fillColorCMYK";
              thisColor["cyan"] = (currentItem.fillColor.spot.color.cyan);
              thisColor["magenta"] = (currentItem.fillColor.spot.color.magenta);
              thisColor["yellow"] = (currentItem.fillColor.spot.color.yellow);
              thisColor["black"] = (currentItem.fillColor.spot.color.black);



              var myColorArray = [thisColor["cyan"], thisColor["magenta"], thisColor["yellow"], thisColor["black"]];
              //alert(myColorArray);


              var myresult = app.convertSampleColor(ImageColorSpace.CMYK, myColorArray, ImageColorSpace.RGB, ColorConvertPurpose.defaultpurpose);

              thisColor["rgb"] = myresult;
              allColor.push(thisColor);
            }

          }

          if (currentItem.fillColor.tint < 100) { bHalftones = true; }
          break;

        case "GradientColor":

          bHalftones = true;
          for (var j = 0; j < currentItem.fillColor.gradient.gradientStops.length; j++) {
            var gStop = currentItem.fillColor.gradient.gradientStops[j].color;

            switch (gStop.typename) {

              case "GrayColor":
                if (colorsArray.toString().indexOf("Black") === -1) {
                  colorsArray.push("Black");
                }
                break;
              case "SpotColor":
                if (colorsArray.toString().indexOf(gStop.spot.name) === -1) {
                  colorsArray.push(gStop.spot.name);
                }
                break;
              case "CMYKColor":
                if (gStop.cyan === 0 && gStop.magenta === 0 && gStop.yellow === 0 && gStop.black > 0) {
                  if (colorsArray.toString().indexOf("Black") === -1) {
                    colorsArray.push("Black");
                  }
                  if (gStop.black < 100) { bHalftones = true; }
                } else if (gStop.cyan === 0 && gStop.magenta === 0 && gStop.yellow === 0 && gStop.black === 0) {
                  break;
                } else {
                  // $.writeln("Four color process.");  
                  bFourCP = true;
                  bHalftones = true;
                }
                break;
              default:
                // $.writeln("Four color process?");  
                bFourCP = true;
                bHalftones = true;
            }

          }
          break;


        case "NoColor":
          break;

        default:

        // $.writeln("The fill color on object number " + i + " is of type " + fillColorType);  
      }


      switch (strokeColorType) {

        case "CMYKColor":

          if (currentItem.strokeColor.cyan === 0 && currentItem.strokeColor.magenta === 0 && currentItem.strokeColor.yellow === 0) {
            if (currentItem.strokeColor.black > 0) {
              if (colorsArray.toString().indexOf("Black") === -1) {
                //  alert("stroke colr pushed as black");
                // colorsArray.push("Black");
                // thisColor["type"]="Strokes";
                // thisColor["cyan"]=currentItem.strokeColor.cyan;
                // thisColor["magenta"]=currentItem.strokeColor.magenta;
                // thisColor["yellow"]=currentItem.strokeColor.yellow;
                // allColor.push(thisColor);   
                //alert("stroke black");
                //console.log(thisColor);
                //alert(thisColor);
              }
              if (currentItem.strokeColor.black < 100) { bHalftones = true; }
            }
          } else {
            // $.writeln("Four color process!");
            //   alert("stroke colr four color process");  
            bFourCP = true;
            bHalftones = true;
          }
          break;

        case "GrayColor":

          if (currentItem.strokeColor.gray > 0) {
            if (colorsArray.toString().indexOf("Black") === -1) {
              colorsArray.push("Black");
            }
            if (currentItem.strokeColor.gray < 100) { bHalftones = true; }
          }
          break;

        case "SpotColor":

          if (colorsArray.toString().indexOf(currentItem.strokeColor.spot.name) === -1) {
            colorsArray.push(currentItem.strokeColor.spot.name);
          }
          if (currentItem.strokeColor.tint < 100) { bHalftones = true; }
          break;

        case "GradientColor":
          bHalftones = true;
          for (var j = 0; j < currentItem.strokeColor.gradient.gradientStops.length; j++) {
            var gStop = currentItem.strokeColor.gradient.gradientStops[j].color;

            switch (gStop.typename) {
              case "GrayColor":
                if (colorsArray.toString().indexOf("Black") === -1) {
                  colorsArray.push("Black");
                }
                break;
              case "SpotColor":
                if (colorsArray.toString().indexOf(gStop.spot.name) === -1) {
                  colorsArray.push(gStop.spot.name);
                }
                break;
              case "CMYKColor":
                if (gStop.cyan === 0 && gStop.magenta === 0 && gStop.yellow === 0 && gStop.black > 0) {
                  if (colorsArray.toString().indexOf("Black") === -1) {
                    colorsArray.push("Black");
                  }
                  if (gStop.black < 100) { bHalftones = true; }
                } else if (gStop.cyan === 0 && gStop.magenta === 0 && gStop.yellow === 0 && gStop.black === 0) {
                  break;
                } else {
                  // $.writeln("Four color process.");  
                  bFourCP = true;
                  bHalftones = true;
                }
                break;
              default:
                // $.writeln("Four color process?");  
                bFourCP = true;
                bHalftones = true;
            }
          }
          break;

        case "NoColor":
          break;

        default:
        // $.writeln("The stroke color on object number " + i + " is of type " + strokeColorType);  
      }
    }
    catch (e) {/* If an error was found with the fill color and/or stroke color, then just skip this particular path item. */ };
    return;
  }
  //document.close(SaveOptions.DONOTSAVECHANGES);  
  // Now we combine the gathered items into a single array and return it.  
  if ((colorsArray.length > 1 && !/HI/.test(templateName.substring(0, 2))) || bFourCP) { bReg = true; }
  prodInfo.push(templateName, colorsArray, bHalftones, bFourCP, bReg);
  //return JSON.stringify(allColor,null,2);
  //return allColor;
  return allColor.toSource();
  //return prodInfo.toSource();  
};


var result = new LabColor().hostObjectDelegate;

var itemcolor = new RGBColor();

function getColorValues(color) {

  if (color === undefined) return undefined;

  else if (color.typename === 'CMYKColor') return [color.cyan, color.magenta, color.yellow, color.black];

  else if (color.typename === 'RGBColor') return [color.red, color.green, color.blue];

  else if (color.typename === 'LabColor') return [color.l, color.a, color.b];

  else if (color.typename === 'SpotColor') return getColorValues(color.spot.color);

  else if (color.typename === 'GrayColor') return [color.gray];

}

function translatetolab(objerenk) {

  sourceColorSpace = ImageColorSpace.RGB;

  destColorSpace = ImageColorSpace.LAB;

  result = app.convertSampleColor(ImageColorSpace.RGB, objerenk, ImageColorSpace.LAB, ColorConvertPurpose.defaultpurpose);

  alert(result);
  alert(result[0]);
  return result[0];

}

function getHostCMYK(labL, labA, labB) {
  //alert("L: "+labL+" A : "+labA+" B : "+labB);
  var myColorArray = [labL, labA, labB];
  var myresult = app.convertSampleColor(ImageColorSpace.LAB, myColorArray, ImageColorSpace.CMYK, ColorConvertPurpose.defaultpurpose);
  //alert(myresult);
  return myresult;
}

function getHostRGB(mCyan, mMagenta, mYellow, mBlack) {
  //alert("L: "+labL+" A : "+labA+" B : "+labB);
  var myColorArray = [mCyan, mMagenta, mYellow, mBlack];
  var myresult = app.convertSampleColor(ImageColorSpace.CMYK, myColorArray, ImageColorSpace.RGB, ColorConvertPurpose.defaultpurpose);
  //alert(myresult);
  return myresult;
}
function getHostRGBFromLAB(labL, labA, labB) {
  //alert("L: "+labL+" A : "+labA+" B : "+labB);
  var myColorArray = [labL, labA, labB];
  var myresult = app.convertSampleColor(ImageColorSpace.LAB, myColorArray, ImageColorSpace.RGB, ColorConvertPurpose.defaultpurpose);
  //alert(myresult);
  return myresult;
}

/**
 * method to add the text on button click. 
 * @param {string} iddTag 
 * @param {*string} content 
 * @param {*boolean} isAppend 
 */
function addTextContent(content) {
  content = decodeURI(content);
  try {
    //check for the active document
    var myDoc = app.activeDocument;
    try {
      //get the selection of done
      var currentItem = app.activeDocument.selection[0];
      //check the selction type
      if ("TextFrame" == currentItem.typename) {
        //if text frame , append the incomming text at the end. 
        //currentItem.words.add(content);   // to append the text at the end.
        //need to replace the existing content. 
        currentItem.contents = content;
        return true.toString();

      } else {
        //if not text frame then , know the type name to proceed further
        //alert(currentItem.typename);
        return "NO_FRAME";
      }

    } catch (err) {


      return "NO_FRAME";
    }

  } catch (err) {
    return "NO_DOC";

  }
}

function updateMissingLinks(encodedInFilePath, inFileBaseName, inFileExt, inVersion) {

  //return error code
  // 0 - Links are updated successfully
  // 1 - No active document
  // 2 - No matching document (input document is not open in host)
  // 3 - Links are updated successfully but version doesn't match
  // 4 - Links update failed
  // 5 - No matching link found (None of the links have same name as input base name)
  // 6 - Download failed
  // 7 - No permission to download
  // 8 - [TODO - remove this error code as we are always relinking matching link] Link found is proper, and matches with input document name.
  // 9 - No relinking action started (ILST case).
  //10 - Active document switched (Photoshop case)

  // *  THIS IS NOT IMPLEMENTED FOR ILST YET, HENCE RETURNING ERR_CODE 9
  var errorCode = 9;
  return errorCode.toString();

  /**
   //Get active document
   var doc = app.activeDocument;
   
   //Return if there is no active document
   if (!doc) {
     errorCode = 1;
     return errorCode.toString();
  }
   * 
   //Decode input file path
   var inFilePath = decodeURI(encodedInFilePath);
   
   // Get file paths from XMP - this returns filepaths of both linked and embedded images
   loadXMPLibrary();
    var xmpFilePaths = getFilePathsFromXMP();
    
    //Get all items from active document
    var allPageItems = doc.pageItems;
    
    //Counter to keep track of linked (placed) and embedded images in active document
    //This is required to map filepath index from XMP with linked image
    var cnt = -1;
  
    //Loop through all the items in active document
    //Relink broken links - update only linked items, ignore embedded items
    //Assumption - order of file paths from XMP matches order of items retrieved from active document
    for (var i = 0; i < allPageItems.length; ++i) {
  
      var pageItem = allPageItems[i];
  
      //Get item type
      //Items shown in Links panel are either embedded (type is RasterItem) or linked (type is PlaceItem)
      var itemType = pageItem.typename;
  
      if ("RasterItem" == itemType) {
        //TODO - Do NOT increment counter for RasterItem which doesn't have file path
        //This check is required to map file path index from XMP correctly with item in document
        //RasterItem can be an image which has file path
        //When an item like Text is rasterized, its type becomes RasterItem and it is displayed in Links panel.
        //Rasterized item like text doesn't have file path and hence counter should not be incremented
        
        //Increment counter 
        ++cnt;
      }
      else if ("PlacedItem" == itemType) {
        
        //Increment counter
        ++cnt;
        
        try {
          //Get file property from item
          //If item doesn't have file property that means link is broken
          var itemFile = pageItem.file;
  
        } catch (error) {
          
          //Check if index is out of bound
          if (cnt >= xmpFilePaths.length)
            continue;
            
            //Get broken link file name from xmp
            var linkedFileName = File(xmpFilePaths[cnt]).name;
  
            //Get linked file extension
            var linkedFileExt = /[^.]+$/.exec(linkedFileName).toString();
            
          //Check if extension matches
          if (inFileExt != linkedFileExt)
          continue;
  
          //Get linked file name without extension
          var linkedFileNameWithoutExt = linkedFileName.substring(0, linkedFileName.lastIndexOf('.'));
          
          //Get linked file base name and version
          var linkedFileBaseName = linkedFileNameWithoutExt;
          var linkedFileVersion = undefined;
          var linkedFileBaseNameAndVersion = getFileBaseNameAndVersion(linkedFileNameWithoutExt);
          if (-1 != linkedFileBaseNameAndVersion.lastIndexOf(",")) {
            linkedFileBaseName = linkedFileBaseNameAndVersion.substring(0, linkedFileBaseNameAndVersion.lastIndexOf(','));
            linkedFileVersion = linkedFileBaseNameAndVersion.substring(linkedFileBaseNameAndVersion.lastIndexOf(',') + 1);
          }
          //alert("linkedFileBaseName = " + linkedFileBaseName + ", linkedFileVersion = " + linkedFileVersion);
  
          if (inFileBaseName != linkedFileBaseName)
            continue;
            
          //Update link
          pageItem.relink(File(inFilePath));
  
          //TODO - catch link update failure
  
          //Check if version number matches
          if (inVersion != linkedFileVersion)
            errorCode = 2;
        }
      }
    }//end of for loop
    
    return errorCode.toString();
    */
}

function loadXMPLibrary() {
  if (undefined == ExternalObject.AdobeXMPScript) {
    try {
      ExternalObject.AdobeXMPScript = new ExternalObject('lib:AdobeXMPScript');
    } catch (error) {
      //Failed loading AdobeXMPScript library
      return false;
    }
  }
  return true;
}

function getFilePathsFromXMP() {

  //Read xmp string - Document XMP is available in Illustrator -> File-> File Info -> Raw Data
  var xmp = new XMPMeta(app.activeDocument.XMPString);

  //Read file paths from XMP - this returns file paths of both embedded and linked images
  var xmpFilePaths = [];
  for (var i = 1; i <= xmp.countArrayItems(XMPConst.NS_XMP_MM, 'Manifest'); i++) {
    var xpath = 'xmpMM:Manifest[' + i + ']/stMfs:reference/stRef:filePath';
    xmpFilePaths.push(xmp.getProperty(XMPConst.NS_XMP_MM, xpath).value);
  }

  return xmpFilePaths;
}

function getFileBaseNameAndVersion(inFileName) {
  //Get basename from inFileName (inFileName is file name without extension)
  //When a document is downloaded from plugin, version number is appended to the downloaded file name
  //Ex: If document name is "blue" and documnent version is 5, then downloaded file name would be blue_v5
  //Basename is name of the file without version number, ex: if filename is "blue_v5", basename is "blue"

  //Return comma separated string with fileBaseName and version Ex: "blue,5"
  //If inFileName doesn't contain version then return inFileName
  var strBaseNameAndVersion = inFileName;

  //Check file name ends with _v*
  var versionStrIndex = inFileName.lastIndexOf("_v");

  if (-1 != versionStrIndex) {

    //Get version number string from file name
    var versionNumString = inFileName.substring(inFileName.lastIndexOf('_v') + 2);

    //Check if it is a valid number. Version number is an integer
    //This check is required in few cases
    //Ex: If file name is blue_vABC, though file name contains _v, ABC is not a valid version number
    var isNumber = /^\d+$/.test(versionNumString);
    if (isNumber) {
      var fileBaseName = inFileName.substring(0, inFileName.lastIndexOf('_v'));
      var version = versionNumString;
      //alert("inFileName = " + inFileName + ", fileBaseName = " + fileBaseName + ", outVersion = " + version);
      strBaseNameAndVersion = fileBaseName + "," + version;
    }
  }

  return strBaseNameAndVersion;
}


function getActiveDocID() {
  var doc = app.activeDocument;
  // get id of the  active document document 
  var docID = doc.id;
  return docID.toString();
}