/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 4, maxerr: 50 */
/*global $, Folder*/

function checkContext() {
  return String(app.documents.length > 0);
}

function exportFile() {
  var filePath = app.activeDocument.fullName;
  return File(filePath).fsName;
}

function getActiveDocumentName() {
  return app.activeDocument.name;
}

/**
 *
 * @param {} filepath : of the document to be opened
 *
 */
function openDocOnHost(filePath) {
  var fileRef = new File(filePath);
  if (fileRef.exists) {
    app.open(fileRef);
  }
}

//This method is executed on click of Place button in Document Details view
function placeImageOnButtonClick(imageType, filepath) {
  placeDocOnHost(filepath);
}

function placeDocOnHost(filePath) {
  var mac = $.os[0] == "M",
    macReg = /^file:\/\//,
    winReg = /^file:\/\/\//,
    file = File(filePath.replace(mac ? macReg : winReg, ""));
  if (!file.exists) return;
  app.toolBoxTools.currentTool = UITools.PLACE_CURSOR_TOOL;
  app.activeDocument.placeGuns.loadPlaceGun(file);
}


function placeImageOn(targetCode, imageType, filePath) {
  var mac = $.os[0] == "M",
    macReg = /^file:\/\//,
    winReg = /^file:\/\/\//,
    file = File(filePath.replace(mac ? macReg : winReg, ""));
  if (!file.exists) return;
  app.toolBoxTools.currentTool = UITools.PLACE_CURSOR_TOOL;
  app.activeDocument.placeGuns.loadPlaceGun(file);
}



function placeTextOn(targetCode) {
  // targetCode = "உயர் புரதத்தை அமைக்கவும்";
  //alert("placing");
  var currPageItem = app.activeDocument;
  var textFrameLength = currPageItem.textFrames.length;
  //alert(textFrameLength);
  //var currentItem = currPageItem.textFrames[textFrameLength - 1];

  //var currentItem = currPageItem.selection[0];

  //var currentItem = currPageItem.textFrames.selection[0];
  //currentItem.addText(filePath);
  //alert(currentItem.contents);
  //var frameContent = currentItem.contents;
  //alert(frameContent);
  //alert(currentItem.textFramePreferences.toSource());
  //currentItem.contents = frameContent + " " + filePath;
  // var currentItem = app.activeDocument.selection[0];

  var currentItem = app.activeDocument.selection[0];     // concidering if user selects the entire text frame. He wants to append. 

  //alert(currentItem.contents);
  // alert(app.activeDocument.selection[1].contents);
  //

  //if (currentItem.typename == "TextFrame") {
  //currentItem.addText(filePath);
  //alert("content is : " + currentItem.contents);

  var frameContent = currentItem.contents;

  //alert(currentItem.textFramePreferences.toSource());
  currentItem.contents = frameContent + " " + targetCode;
  //} else {
  // alert("no textFrame selected");
  //}; 

}


function placeTextOnEmptyFrame(targetCode, a, b) {
  //alert("here okkkk");
  var currPageItem = app.activeDocument;
  var textFrameLength = currPageItem.textFrames.length;
  var currentItem = app.activeDocument.selection[0];     // concidering if user selects the entire text frame. He wants to append. 

  var frameContent = currentItem.contents;

  //alert(currentItem.textFramePreferences.toSource());
  currentItem.contents = frameContent + " " + targetCode;

}

function removeDefualtDropedText(targetCode, imageType, filePath) {
  var currPageItem = app.activeDocument;
  for (var i = 0; i < currPageItem.textFrames.length; i++) {
    var currentItem = currPageItem.textFrames[i];
    if (currentItem.contents == targetCode) {
      currentItem.remove();
    }
  }
}

//to check and remove all the existing swatches
function CheckforSwatchGroup(swatchGroupName) {
  var doc = app.activeDocument; // get the doc 
  try {
    for (var i = doc.colorGroups.length - 1; i >= 0; i--) {
      //alert(doc.colorGroups[i].count());
      for (var j = doc.colorGroups[i].colorGroupSwatches.length - 1; j >= 0; j--) {
        //alert(j+"  "+doc.colorGroups[i].colorGroupSwatches[j].swatchItemRef);
        doc.colorGroups[i].colorGroupSwatches[j].swatchItemRef.remove();
      }
    }
    return true;
  } catch (e) {
    //alert("not there to remove");
    //return false;
  }

}

//Append operation : if swatch group already there. 
function refreshSwatchGroup(swatchGroupName) {
  //alert("In JSX");
  var doc = app.activeDocument; // get the doc
}



function addSwtchestoGroupLABColors(swatchGroupName, swatchName, swatchValue, swatchLAB_L, swatchLAB_A, swatchLAB_B) {
  //alert(swatchLAB_A);
  var doc = app.activeDocument;
  var l_LAB = parseFloat(swatchLAB_L);
  var a_LAB = parseFloat(swatchLAB_A);
  var b_LAB = parseFloat(swatchLAB_B);
  var swatchGroup = swatchGroupName;
  try {
    var swGrp = app.activeDocument.colorGroups.itemByName(swatchGroup);
    swGrp.name = swatchGroup;
    //alert("removed");
    //var myColor=app.activeDocument.colors.add();
    // var swGrp = app.activeDocument.ColorGroup.add();

  }
  catch (e) {
    var swGrp = app.activeDocument.colorGroups.add();
    //alert("done adding");
    swGrp.name = swatchGroup;
    //alert("grp NOT  there");
    //var swGrp =  app.activeDocument.colorGroups.add();
    //alert("done adding");
    //swGrp.name=swatchGroup;

    // alert("error in getting swatches");
    //var swGrp = doc.swatchGroups.add();
    // swGrp.name = swatchGroupName;
    // var newSpot = doc.spots.add();
    // newSpot.name = swatchName;

    // alert("dont have");
    // var myColorName=swatchName;
  }
  try {

    //alert(swGrp.name);
    swatchName = decodeURIComponent(swatchName);
    var myColor = app.activeDocument.colors.item(swatchName);
    //alert(myColor.name);
    myColor.remove();

  } catch (e) {


  }

  finally {
    // var myColor=app.activeDocument.colors.add();

    //var swGrp =  app.activeDocument.colorGroups.add();
    //alert("done adding");
    // swGrp.name=swatchGroup;

    var myColor = app.activeDocument.colors.add();
    //var myColor= app.activeDocument.colorGroups.itemByName(swatchGroup).add();
    //alert("here");
    var myColorName = swatchName;
    var myColorSpace = ColorSpace.LAB;

    // for LAB, specify three values representing L (Range: 0 to 100), A (Range: -128 to 127), and B (Range: -128 to 127); 
    var myColorValue = [l_LAB, a_LAB, b_LAB];
    var myColorModel = ColorModel.SPOT;
    myColor.properties = { name: myColorName, model: myColorModel, space: myColorSpace, colorValue: myColorValue };
    //alert("going to add");
    swGrp.colorGroupSwatches.add(myColor);

    //    alert("done adding");

    return true;
  }

}

/**
 * 
 * @param {*} iddTagg :the tag to be cretated as per ICXML 
 *  @param {*} content : the icxml content
 * @param {*} isAppend :to append or replace
 */
function addTextContent(iddTag, content, isAppend) {
  content = decodeURI(content);
  var iddContent = content;
  //var myiddContent = ' <body><p pstyle=""><span cstyle="Underline">Open / Close</span></p>↵</body>';
  //alert(myiddContent);
  //iddContent = myiddContent;
  //var iddContent = '<body><p pstyle=""><span cstyle="Italic">Seven ml of NovoEight® contains approximately 62.5 IU of human coagulation factor VIII (rDNA), turoctocog alfa after reconstitution </span></p><p pstyle = "" > <span cstyle="Italic">Powder: Sodium chloride, L-histidine, sucrose, polysorbate 80, L-methionine, calcium chloride dihydrate, sodium hydroxide, hydrochloric acid</span></p><p pstyle=""><span cstyle="Italic">Solvent: Sodium chloride, water for injections</span></p><p pstyle=""><span cstyle="Italic">Pack contains: 1 powder vial, 4 ml </span></p><p pstyle=""><span cstyle="Italic">solvent in pre-filled syringe, plunger rod </span></p><p pstyle=""><span cstyle="Italic">and vial adapter</span> </p></body >';
  //var iddContent = '<body><p pstyle=""><span cstyle="italic">One ml of NovoEight® contains approximately 62.5 IU of human coagulation factor VIII (rDNA), turoctocog alfa after reconstitution </span></p></body>';

  // Need to define that user has selected a proper cursor positon for performing operation
  var isPositionOK;

  //first check if active documenmt is availabe
  try {
    var myDocument = app.activeDocument;
    var currentItem = app.activeDocument.selection[0];
    try {
      var selectedContext = currentItem.constructor.name;
      //alert(currentItem);

      if (selectedContext == "TextFrame") {
        //currentItem.contentType == 1952412773 ; 
        // check if the parent story is already tagged
        var isTaqggedStory = checkForTaggedStory(currentItem);
        //alert(isTaqggedStory);
        if (true == isTaqggedStory) {
          var isTagCreated = createInddTag(iddTag);
          isPositionOK = true;
          try {
            //alert("in try");
            //try if textFrame/story already have xml elements 
            //then associate the new xml element at the last
            var myNewXMLelement = app.activeDocument.selection[0].associatedXMLElement.xmlElements.add(iddTag);
          } catch (e) {
            //alert("in catch");
            //we are here means no xml element is assigned to selected text frame
            // and  similary no styling is provided
            var myNewXMLelement = myDocument.xmlElements.item(0).xmlElements.add(iddTag);

            //preserve the available existing text frame content(which is raw and has no styling)
            // and also preserve the new indd content coming
            // this is done by using markup method
            currentItem.parentStory.markup(myNewXMLelement);
          }
        } else {
          return isTaqggedStory.toString();
        }
      }
      else if (selectedContext == "InsertionPoint") {
        //alert("Insertion point");
        try {
          //alert(app.selection[0].associatedXMLElements[0].length);
          var parentStory = currentItem.parentStory;
          //alert(parentStory.associatedXMLElements[0].length);

          var isStoryORuntagged = checkForPosition(currentItem);
          //if story then only allow adding the text at cursor position
          if (isStoryORuntagged == true) {

            isPositionOK = true;
            var isTagCreated = createInddTag(iddTag);
            if (parentStory.contents == "") {
              //indicaates there is no conntent on the selected text frame and is also untagged or is a story
              try {
                //alert(currentItem.parentStory.constructor.name);
                var isAddedtoNewFrame = addTextToEmptyTextFrame(iddContent, iddTag);
                if (isAddedtoNewFrame == true) {
                  return isPositionOK.toString();

                } else {
                  var unknownError = "undefined";
                  return unknownError.toString();
                }

              } catch (e) {
                //alert("here in cathc");
                var unknownError = "undefined";
                return unknownError.toString();
              }


            }
            else {
              var currentInsertionPoint = currentItem;
              currentItem.insertionPoints[0].contents = "$";
              var dummyTextSelector = parentStory.characters[(currentInsertionPoint.index - 1)];


              try {
                //alert(dummyTextSelector.words[0].contents);
                // now select the newly added text

                app.select(dummyTextSelector, SelectionOptions.REPLACE_WITH); // replace the previously selected option
                var myDummyText = app.activeDocument.selection;
                //alert(app.activeDocument.selection.length);
                myDummyText = myDummyText[0];


                //var myNewXMLelement = app.activeDocument.selection[0].associatedXMLElement.xmlElements.add(iddTag, myDummyText);
                var myNewXMLelement = app.activeDocument.xmlElements[0].xmlElements.add(iddTag, myDummyText);
                //var myNewXMLelement = app.activeDocument.xmlElements[0].xmlElements.add(iddTag);

                //alert(text);
                //           var myNewXMLelement = app.activeDocument.parentStory.xmlElements[0].xmlElements.add(iddTag, myDummyText);
                // var myNewXMLelement = app.activeDocument.selection[0].parentStory.associatedXMLElement.xmlElements.add(iddTag, myDummyText);
              } catch (e) {
                //alert(e);
              }
            }
          } else {
            //alert("can't modify the existing tag, try placing at story level");
            return isStoryORuntagged;
          }




        } catch (e) {

          //alert(e);
        }

      }
      // Todo:  Test for  TextStyleRange 
      else if (selectedContext == "Word" || selectedContext == "Text" || selectedContext == "Character" || selectedContext == "Line" || selectedContext == "Paragraph" || selectedContext == "TextColumn" || selectedContext == "TextStyleRange") {
        try {
          var isStoryORuntagged = checkForPosition(currentItem);
          if (isStoryORuntagged == true) {
            var isTagCreated = createInddTag(iddTag);

            isPositionOK = true;
            var myDummyText = app.activeDocument.selection;
            //alert(app.activeDocument.selection.length);
            myDummyText = myDummyText[0];
            var myNewXMLelement = app.activeDocument.xmlElements[0].xmlElements.add(iddTag, myDummyText);
          } else {
            return isStoryORuntagged;
          }

        } catch (e) {

          //alert(e);
        }


      }

      else {
        //do nothing , to handle some other case
        // some image / smart object or path item selected
        // alert("No Text frame or cursor Position selected");
        var wrongSelection = "WRONG_SELECTION";
        return wrongSelection.toString();
      }

    } catch (e) {
      //alert("No Text frame or cursor Position selected");
      // todo :  no cursor selected  it try maching the tag
      //return no selection error string;
      var noSelection = "NO_SELECTION";
      return noSelection.toString();
      //alert("Go for Tag Matching");

    }
    // Apply the content to this tag.
    applyContent(iddContent, myNewXMLelement);
    return isPositionOK.toString();

  } catch (error) {
    var reason = "NO_DOC";
    return reason.toString();
  }
}






/**
 * 
 * @param {*} inddTagName // the element type Tag name  to be created
 */
function createInddTag(inddTagName) {
  var myDocument = app.activeDocument;
  try {
    // create a new XML Tag,  
    //fails and goes to catch block if tag already exists
    var myXMLTagA = myDocument.xmlTags.add(inddTagName);
    // return true if xml Tag gets created
    return true;
  } catch (e) {
    //return flase for no new creation of xml tag since tag already exist
    return false;
  }

}

function checkForPosition(currentItem) {
  try {
    var isStory = currentItem.associatedXMLElements[0].markupTag.name;
    //alert(currentItem.constructor.name);
    //alert(currentItem.associatedXMLElements.length);
    //alert(isStory);
    if (isStory == "Story") {
      return true;
    } else {
      return isStory;
    }
  } catch (e) {
    //alert("here in ctach");
    // there is no tagging available for the selected postion , we can treat this as Story
    // using Adobe Object Property , Hence return true.
    return true;
  }
}

/**
 * @param {*} currentItem the current selected item
 * return true if the seleted frame is a story and is not tagged 
 * 
 */
function checkForTaggedStory(currentItem) {
  try {
    var taggedName = currentItem.associatedXMLElement.markupTag.name;
    if (taggedName == "Story") {
      return true;
    } else {
      return taggedName;
    }
  } catch (e) {
    //alert("here in ctach");
    // there is no tagging available for the selected postion , we can treat this as Story
    // using Adobe Object Property , Hence return true.
    return true;
  }
}

/**
 * Method to add text under story for an emepty text frame
 * @param {*} inddtag  tag that is created 
 * @param {*} iddContent  the content to be placed
 */
function addTextToEmptyTextFrame(iddContent, iddTag) {

  var currentItem = app.activeDocument.selection[0];
  var parentStory = currentItem.parentStory;

  var currentInsertionPoint = currentItem;
  currentItem.insertionPoints[0].contents = "$ ";
  //adding a space to treat the selected text frame as story 
  //and make use of defualt property of Host to append child element under story

  var dummyTextSelector = parentStory.characters[(currentInsertionPoint.index - 2)];
  try {
    // now select the newly added text

    app.select(dummyTextSelector, SelectionOptions.REPLACE_WITH); // replace the previously selected option
    var myDummyText = app.activeDocument.selection;

    myDummyText = myDummyText[0];

    var myNewXMLelement = app.activeDocument.xmlElements[0].xmlElements.add(iddTag, myDummyText);

    applyContent(iddContent, myNewXMLelement);

    var dummySpaceSelector = parentStory.characters[(currentInsertionPoint.index - 1)];
    try {
      // now select the newly added dummy space

      app.select(dummySpaceSelector, SelectionOptions.REPLACE_WITH); // replace the previously selected option
      var myDummySpace = app.activeDocument.selection;
      myDummySpace = myDummySpace[0];
      myDummySpace.contents = "";
      //remove the newly added content

    } catch (e) {
      return false;
    }
    //alert("done");
    return true;

  } catch (e) {
    //alert("add to new catch");
    //alert(e);
    return false;
  }

}





/**
 * apply all text on matched tag in full push button click
 * @param {*} content 
 * @param {*} isAppend
 */
function addAllTextContent(inddtag, content) {

  var inddContent = [];
  var taggedData = {};
  content = decodeURI(content);

  taggedData[inddtag] = content;
  inddContent.push(taggedData);

  //alert(content);
  //var jsonObj = JSON.parse(content);
  //var jsonObj = content.tosource();
  //var newParsedData = $.evalFile(content);
  //alert(jsonObj);


  // Get the top XMLItems in the active document.

  var xmlElements = app.activeDocument.xmlElements;

  // Get all nested XMLElements in those.
  var allXmlElements = getAllXmlElements(xmlElements);

  // Apply the content to the XML Elements.
  applyAllContent(inddContent, allXmlElements);
}

/**
 * 
 * @param {String} inDocID 
 * @param {String} encodedInFilePath 
 * @param {String} inFileBaseName 
 * @param {String} inFileExt 
 * @param {String} inVersion 
 */
function updateMissingLinks(inDocID, encodedInFilePath, inFileBaseName, inFileExt, inVersion) {
  
  //return error code
  // 0 - Links are updated successfully
  // 1 - No active document
  // 2 - No matching document (input document is not open in host)
  // 3 - Links are updated successfully but version doesn't match
  // 4 - Links update failed
  // 5 - No matching link found (None of the links have same name as input base name)
  // 6 - Download failed
  // 7 - No permission to download
  // 8 - [TODO - remove this error code as we are always relinking matching link] Link found is proper, and matches with input document name.
  // 9 - No relinking action started (ILST case).
  //10 - Active document switched (Photoshop case)

  var errorCode = 0;

  //Use this variable to return error if there is no active document
  var activeDocId = undefined;

  try {
    //Get active document
    var doc = app.activeDocument;
    activeDocId = doc.id;

    //Check if documentId is same as active document
    //If yes proceed to update links
    //If no, get all open documents and compare with documentId
    //If document id matches with any open document, proceed to update links
    //else return error
    if (doc.id == inDocID) {
      doc = app.activeDocument;
    } else {

      // get the document with predefined id ,
      // i.e. document on which the relink operation was initiated[case of active document switch]
      // try to fill the doc variable with inDocId document.
      var numOfdocs = app.documents.length;
      // Flag to identify the document
      var foundOriginalDoc = false;
      for (var i = 0; i < numOfdocs; ++i) {

        // Compare the doc ids on host.
        if (inDocID == app.documents[i].id) {
          // Assign the doc variable to fetched one.
          doc = app.documents[i];
          foundOriginalDoc = true;
          break;
        }
      }

      // Case that the document is closed.
      if (!foundOriginalDoc) {
        // do nothing and return 
        errorCode = 2;
        return errorCode.toString();
      }
    }
    
    //Decode input file path
    var inFilePath = decodeURI(encodedInFilePath);

    //Get all links from active document
    //this will fail if the doc with id is closed or doesn't exist
    var allLinks = doc.links;

    //Loop through all the links
    //Update missing link if input file extension and base name matches with link
    var numOfLinks = allLinks.length;
    
    //This is needed to check if there is any link which has same base name and extension as input basename and extension
    //Return error code if no matching link found in input document
    var matchingLinkFound = false;

    for (var i = 0; i < numOfLinks; ++i) {

      //Get linked file name from missing link
      var linkedFileName = allLinks[i].name;

      //Get linked file extension
      var linkedFileExt = /[^.]+$/.exec(linkedFileName).toString();

      //Check if extension matches
      if (inFileExt != linkedFileExt) {
        continue;
      }

      //Get basename from linked file name
      //When a document is downloaded from plugin, version number is appended to the downloaded file name
      //Ex: If document name is "blue" and doc version is 5, then downloaded file name would be blue_v5
      //Basename is name of the file without version number, ex: "blue"
      var linkedFileNameWithoutExt = linkedFileName.substring(0, linkedFileName.lastIndexOf('.'));

      //Check if linked file name ends with _v*
      var linkedFileBaseName = linkedFileNameWithoutExt;
      var linkedFileVersion = undefined;
      var linkedFileVersionStrIndex = linkedFileNameWithoutExt.lastIndexOf("_v");

      if (-1 != linkedFileVersionStrIndex) {

        //Get version number string from linked file name
        var versionNumString = linkedFileNameWithoutExt.substring(linkedFileNameWithoutExt.lastIndexOf('_v') + 2);

        //Check if it is a valid number. Version number is an integer
        //This is required in few cases
        //Ex: If file name is blue_vABC, though file name contains _v, ABC is not a valid version number
        var isNumber = /^\d+$/.test(versionNumString);
        if (isNumber) {
          linkedFileBaseName = linkedFileNameWithoutExt.substring(0, linkedFileNameWithoutExt.lastIndexOf('_v'));
          linkedFileVersion = versionNumString;
        }
      }

      //Check if base name matches
      if (inFileBaseName != linkedFileBaseName) {
        continue;
      }
      
      //Link matched with input file name, so update bool
      matchingLinkFound = true;

      //Update link
      try {

        //Update only if the link is not embedded
        if (LinkStatus.LINK_EMBEDDED != allLinks[i].status)
          allLinks[i].relink(File(inFilePath));

        //Check if version number matches
        if ( (undefined != linkedFileVersion) && (inVersion != linkedFileVersion) )
          errorCode = 3;
      }
      catch (error) {
        //Link update failed, update error code
        errorCode = 4;
      }
    }//end of for loop

    if (!matchingLinkFound)
      errorCode = 5;

  } catch(error) {
    
    if(undefined == activeDocId)
      errorCode = 1;
    else
      errorCode = 4; //Problem in getting links or updating links
  }

  return errorCode.toString();
}

function getActiveDocID() {
  var doc = app.activeDocument;
  // get id of the  active document document 
  var docID = doc.id;
  return docID.toString();
}
