/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 2, maxerr: 50 */
/*global $, Folder*/

function checkContext() {
  return String(app.documents.length > 0);
}

function exportFile() {
  var filePath = app.activeDocument.fullName;
  return File(filePath).fsName;
}

function openDocOnHost(filePath) {
  var fileRef = new File(filePath); // samples is a folder resides in Program Files\Adobe\Adobe Photoshop CS5\samples
  if (fileRef.exists) {
    app.open(fileRef);
  }
}

function getActiveDocumentName() {
  return app.activeDocument.name;
}

function placeDocOnHost(filePath) {
  var fileRef = new File(filePath); // samples is a folder resides in Program Files\Adobe\Adobe Photoshop CS5\samples
  if (fileRef.exists) {
    app.open(fileRef);
  }
}

//This method is executed on click of Place button in Document Details view
function placeImageOnButtonClick(imageType, filepath) {
  placeImageOn("", "", filepath);
}

function placeImageOn(targetCode, imageType, filepath) {   // param 1 and 2 is not mandatory for photoshop
  var doc = app.activeDocument;
  if (!doc) {
    alert("Improper active document on host!");
    return;
  }

  // var startRulerUnits = app.preferences.rulerUnits;
  // app.preferences.rulerUnits = Units.PIXELS;
  // var thisLayer = activeDocument.artLayers.add();
  // thisLayer.kind = LayerKind.TEXT;
  // thisLayer.name = "GETSET";
  // var textProperty = thisLayer.textItem;
  // textProperty.contents = "GetSet for Apple and Lime, HIGH INV ITAMINS: B12,D3";
  // textProperty.kind = TextType.POINTTEXT;


  var desc2 = new ActionDescriptor();
  desc2.putInteger(charIDToTypeID("Idnt"), 2);
  desc2.putPath(charIDToTypeID("null"), new File(filepath));
  desc2.putBoolean(charIDToTypeID("Lnkd"), true); // only needed if you wish linked images
  desc2.putEnumerated(
    charIDToTypeID("FTcs"),
    charIDToTypeID("QCSt"),
    charIDToTypeID("Qcsa")
  );
  var desc3 = new ActionDescriptor();
  desc3.putUnitDouble(charIDToTypeID("Hrzn"), charIDToTypeID("#Pxl"), 0.0);
  desc3.putUnitDouble(charIDToTypeID("Vrtc"), charIDToTypeID("#Pxl"), 0.0);
  desc3.putBoolean(charIDToTypeID("Lnkd"), true);
  desc2.putObject(charIDToTypeID("Ofst"), charIDToTypeID("Ofst"), desc3);
  desc2.putUnitDouble(charIDToTypeID("Wdth"), charIDToTypeID("#Prc"), 70); // in percent of the longest side of your base image
  desc2.putUnitDouble(charIDToTypeID("Hght"), charIDToTypeID("#Prc"), 70);
  executeAction(charIDToTypeID("Plc "), desc2, DialogModes.NO);
  return app.activeDocument.activeLayer;
}

// remove default text if any. 
function removeDefualtDropedText(targetCode, imageType, filePath) {
  var currPageItem = app.activeDocument;
  // do nothing , since no text being dropped by default. 
}
//To check and remove all the existing swatches.[when replace is opted] 
function CheckforSwatchGroup(swatchGroupName) {
  // loop all groups and remove the each swatches withing group  

  var doc = app.activeDocument; // get the doc 
  try {
    alert(doc.colors.length);
    for (var i = doc.colorGroups.length - 1; i >= 0; i--) {
      //alert(doc.colorGroups[i].count());
      for (var j = doc.colorGroups[i].colorGroupSwatches.length - 1; j >= 0; j--) {
        //alert(j+"  "+doc.colorGroups[i].colorGroupSwatches[j].swatchItemRef);
        doc.colorGroups[i].colorGroupSwatches[j].swatchItemRef.remove();
      }
    }
    return true;
  } catch (e) {
    //alert("not there to remove");
    //return false;
  }

}

// add swathes onto the swatch color panel.[it appends to the existing swatches on to the panel by default] 

function addSwtchestoGroupLABColors(swatchGroupName, swatchName, swatchValue, swatchLAB_L, swatchLAB_A, swatchLAB_B) {
  //alert(swatchLAB_A);
  var doc = app.activeDocument;
  try {
    // var swGrp =app.activeDocument.colors.getByName(swatchName);
    //alert("color there") 

    // var newSpot = doc.spots.add();
    // newSpot.name = swatchName;
    var l_LAB = parseFloat(swatchLAB_L);
    var a_LAB = parseFloat(swatchLAB_A);
    var b_LAB = parseFloat(swatchLAB_B);
    //alert(l_LAB+" "+a_LAB+" " +b_LAB);

    var name = decodeURIComponent(swatchName);
    var addColorDescriptor = new ActionDescriptor();
    // Get reference to Swatches panel
    var swatchesPanelReference = new ActionReference();
    swatchesPanelReference.putClass(stringIDToTypeID('colors'));
    addColorDescriptor.putReference(stringIDToTypeID('null'), swatchesPanelReference);
    // Setup a swatch and give it a name
    var descriptorSwatch = new ActionDescriptor();
    descriptorSwatch.putString(stringIDToTypeID('name'), name);
    // Add RGB color information to the swatch
    var descriptorColor = new ActionDescriptor();
    /*
    descriptorColor.putDouble(stringIDToTypeID('ltnss'),swatchLAB_L);    //lumincence    //lmnc
    descriptorColor.putDouble(stringIDToTypeID('a'),swatchLAB_A); // grain = green
    descriptorColor.putDouble(stringIDToTypeID('b'),swatchLAB_B);
   */
    descriptorColor.putDouble(charIDToTypeID("Lmnc"), swatchLAB_L);
    descriptorColor.putDouble(charIDToTypeID("A   "), swatchLAB_A);
    descriptorColor.putDouble(charIDToTypeID("B   "), swatchLAB_B);
    // Add RGB to the swatch
    // alert("RGB values set");
    descriptorSwatch.putObject(stringIDToTypeID('color'), stringIDToTypeID('labColor'), descriptorColor);
    // Add swatch to the color descriptor
    addColorDescriptor.putObject(stringIDToTypeID('using'), stringIDToTypeID('colors'), descriptorSwatch);
    // Send to Photoshop
    executeAction(stringIDToTypeID('make'), addColorDescriptor, DialogModes.NO);

  }
  catch (e) {
    // alert("in catch");

  }
  finally {

    return swGrp;
  }
}

/**
 * method to add the text on button click. 
 * @param {string} iddTag (tag name)
 * @param {*string} content  (text content)
 * @param {*boolean} isAppend (Append or replace) 
 */
function addTextContent(content) {
  content = decodeURI(content);
  //alert();
  try {
    var myDoc = app.activeDocument;
    try {


      // var thisLayer = activeDocument.artLayers[0];
      var thisLayer = activeDocument.activeLayer;
      //alert(thisLayer.kind);
      if (LayerKind.TEXT == thisLayer.kind) {
        var myItemRefText = thisLayer.textItem;
        // executeAction(idSelected, myDescriptor, DialogModes.NO);
        //alert(textItemRef.contents);
        myItemRefText.contents = content;
        return true.toString();
      } else {
        return "NO_FRAME";
      }
      //thisLayer.kind = LayerKind.TEXT;
      // var mySelection = new selection();
      // var mySelection = new ActionDescriptor();
      // var selectionName = mySelection.getString(stringIDToTypeID('name'));
      // //var mySelection = myDoc.selection[0];

      // alert(selectionName);

      return true.toString();

    } catch (error) {
      return "NO_FRAME";
    }

  } catch (error) {
    return "NO_DOC";
  }
}

function updateMissingLinks(inDocID, encodedInFilePath, inFileBaseName, inFileExt, inVersion) {

  //return error code
  // 0 - Links are updated successfully
  // 1 - No active document
  // 2 - No matching document (input document is not open in host)
  // 3 - Links are updated successfully but version doesn't match
  // 4 - Links update failed
  // 5 - No matching link found (None of the links have same name as input base name)
  // 6 - Download failed
  // 7 - No permission to download
  // 8 - [TODO - remove this error code as we are always relinking matching link] Link found is proper, and matches with input document name.
  // 9 - No relinking action started (ILST case).
  //10 - Active document switched (Photoshop case)

  var errorCode = 0;

  //Use this variable to return error if there is no active document
  var activeDocId = undefined;

  try {

    //Get active document
    var doc = app.activeDocument;
    activeDocId = doc.id;
    
    //check if inDocID is same as active document ID 
    if (doc.id != inDocID) {
      //it means either active document switched or closed
      // get the document with predefined id ,
      // i.e. document on which the relink operation was initiated[case of active document switch]
      // try to fill the doc variable with inDocId document.
      var numOfdocs = app.documents.length;
      // Flag to identify the document
      var foundOriginalDoc = false;

      for (var i = 0; i < numOfdocs; ++i) {

        // Compare the doc ids on host.
        if (inDocID == app.documents[i].id) {
          // means active document switched.
          //doc = app.documents[i];
          foundOriginalDoc = true;
          break;
        }
      }

      //check if active doc switched or not there
      // Case that the document is closed.
      if (!foundOriginalDoc) {
        // means active document closed
        // do nothing and return 
        errorCode = 2;
        return errorCode.toString();
      } else {
        // means active document swithced
        errorCode = 10;
        return errorCode.toString();
      }
    }

    //Decode input file path
    var inFilePath = decodeURI(encodedInFilePath);

    //Get all layers from active document
    //For each layer
    //  1. Make the layer active
    //    In Photoshop to perform any action on document/layer/channel etc,. that object needs to be set as active
    //    Here the action is to relink a layer with input file path if the link is missing
    //  2. Check if layer has Smart Object and get it (Linked or Embedded image type is Smart Object)
    //  3. Get link if exists from SmartObject (This is to find out if this is a linked image. Embedded image doesn't have link property)
    //  4. Get filepath from link
    //  5. Relink with the input file path provided basename and extension matches

    //Get all layers from active document
    var allLayers = doc.layers;
    var numOfLayers = allLayers.length;

    //This is needed to check if there is any link which has same base name and extension as input basename and extension
    //Return error code if no matching link found in input document
    var matchingLinkFound = false;

    for (var i = 0; i < numOfLayers; ++i) {

      //Make current layer as active
      doc.activeLayer = allLayers[i];

      //Create action reference object
      var actionRef = new ActionReference();
      actionRef.putProperty(stringIDToTypeID("property"), stringIDToTypeID("smartObject"));
      actionRef.putEnumerated(stringIDToTypeID("layer"), stringIDToTypeID("ordinal"), stringIDToTypeID("targetEnum"));
      var obj = executeActionGet(actionRef);

      if (obj.hasKey(stringIDToTypeID("smartObject"))) {

        //Get smartObject
        obj = obj.getObjectValue(stringIDToTypeID("smartObject"));

        if (obj.hasKey(stringIDToTypeID("link"))) {

          //Get linked file path
          //For missing link, getPath method may not always return linked file path
          //So check link type and accordingly get file path using getPath or getString method
          var linkType = obj.getType(stringIDToTypeID("link"));
          var linkedFilePath = undefined;

          switch (linkType) {
            case DescValueType.ALIASTYPE:
              linkedFilePath = obj.getPath(stringIDToTypeID("link"));
              break;

            case DescValueType.STRINGTYPE:
              linkedFilePath = obj.getString(stringIDToTypeID("link"));
              break;

            default:
            //alert("Failed to get linked file path");
          }

          //Create file object from linked file path
          var linkedFileObj = File(linkedFilePath);

          //Get linked file name
          //If file name has spaces or other special characters it is encoded
          //Ex: If filename is "abc xyz", name retrieved from file object is "abc%20xyz"
          //Hence decode filename
          var linkedFileNameFromFileObj = linkedFileObj.name;
          var linkedFileName = decodeURI(linkedFileNameFromFileObj);

          //Get linked file extension
          var linkedFileExt = /[^.]+$/.exec(linkedFileName).toString();

          //Check if extension matches
          if (inFileExt != linkedFileExt)
            continue;

          //Get linked file name without extension
          var linkedFileNameWithoutExt = linkedFileName.substring(0, linkedFileName.lastIndexOf('.'));

          //Get linked file base name and version
          var linkedFileBaseName = linkedFileNameWithoutExt;
          var linkedFileVersion = undefined;
          var linkedFileBaseNameAndVersion = getFileBaseNameAndVersion(linkedFileNameWithoutExt);
          if (-1 != linkedFileBaseNameAndVersion.lastIndexOf(",")) {
            linkedFileBaseName = linkedFileBaseNameAndVersion.substring(0, linkedFileBaseNameAndVersion.lastIndexOf(','));
            linkedFileVersion = linkedFileBaseNameAndVersion.substring(linkedFileBaseNameAndVersion.lastIndexOf(',') + 1);
          }

          //Check if file base name matches
          if (inFileBaseName != linkedFileBaseName)
            continue;

          //Link matched with input file name, so update bool
          matchingLinkFound = true;

          //Update link
          try {
            var desc = new ActionDescriptor();
            desc.putPath(stringIDToTypeID("null"), File(inFilePath));
            executeAction(stringIDToTypeID("placedLayerRelinkToFile"), desc, DialogModes.NO);

            //Check if version number matches
           if ( (undefined != linkedFileVersion) && (inVersion != linkedFileVersion) )
              errorCode = 3;
          }
          catch (error) {
            //Link update failed, update error code
            errorCode = 4;
          }
        }
      }
    }//end of for loop

    if (!matchingLinkFound)
      errorCode = 5;

  } catch(error) {

    if(undefined == activeDocId)
      errorCode = 1;
    else
      errorCode = 4; //Problem in getting links or updating links
  }

  return errorCode.toString();
}

function getFileBaseNameAndVersion(inFileName) {
  //Get basename from inFileName (inFileName is file name without extension)
  //When a document is downloaded from plugin, version number is appended to the downloaded file name
  //Ex: If document name is "blue" and documnent version is 5, then downloaded file name would be blue_v5
  //Basename is name of the file without version number, ex: if filename is "blue_v5", basename is "blue"

  //Return comma separated string with fileBaseName and version Ex: "blue,5"
  //If inFileName doesn't contain version then return inFileName
  var strBaseNameAndVersion = inFileName;

  //Check file name ends with _v*
  var versionStrIndex = inFileName.lastIndexOf("_v");

  if (-1 != versionStrIndex) {

    //Get version number string from file name
    var versionNumString = inFileName.substring(inFileName.lastIndexOf('_v') + 2);

    //Check if it is a valid number. Version number is an integer
    //This check is required in few cases
    //Ex: If file name is blue_vABC, though file name contains _v, ABC is not a valid version number
    var isNumber = /^\d+$/.test(versionNumString);
    if (isNumber) {
      var fileBaseName = inFileName.substring(0, inFileName.lastIndexOf('_v'));
      var version = versionNumString;
      strBaseNameAndVersion = fileBaseName + "," + version;
    }
  }

  return strBaseNameAndVersion;
}

function getActiveDocID() {
  var doc = app.activeDocument;
  // get id of the  active document
  var docID = doc.id;
  return docID.toString();
}